<template>
	<view>
		<!-- 胶囊 -->
		<mvBar :mysNavConfig="mysNavConfig"></mvBar>
		<view :style="{marginTop:navH}"></view>
		<view class="basicInfo">
			<image :src="mainImg" style="width: 150rpx;height: 150rpx;" mode="">
			</image>
			<view class="basicInfo_txt">
				<p style="margin-bottom: 10rpx;font-size: 36rpx;">{{selection.selection_name}}</p>
				<p>售价：￥{{selection.show_estimated_cost}} &nbsp;&nbsp;&nbsp;&nbsp; 佣金：{{selection.commission_rate}}%</p>
				<p v-if="selection.task_mode === 1">额外悬赏：￥{{selection.show_task_reward}}</p>
			</view>
		</view>

		<view class="address">
			<view>
				<image class="address_icon" :src="picture.icon_loc" mode="">
				</image>
			</view>
			<view style="width: 70%;">
				<view style="display: flex;">
					<p class='ipon' style="padding-right: 100rpx;">{{address.receiver_name}}</p>
					<p class='ipon'>{{address.phone_number}}</p>
				</view>
				<p class='ipon'>{{address.full_detail_addr}}</p>
			</view>
			<view class="address_edit" @click="editAddress()">
				<image :src="picture.icon_edit" mode="">
				</image>
			</view>
		</view>

		<view class="keyInfo">
			<p style="margin-bottom: 30rpx;font-size: 36rpx;">任务要求</p>
			<p>内容形式：{{selection.show_content_type}}</p>
			<p>带货链接：{{selection.product_url}}
				<image :src="picture.icon_copy" mode="" class="copy-img" @click="handleCopy('123')" />
			</p>
			<p>领样形式：{{selection.show_sample_mode}}</p>
			<p>领样条件：{{selection.sample_condition}}</p>
			<p>任务形式：{{selection.show_task_mode}}</p>
			<p>返现&悬赏条件：{{selection.reward_condition}}</p>
		</view>

		<view class="account" @click="editAccount()">
			<view class="account_txt">
				<image :src="selection.PlatformInfo.platform_icon" mode=""></image>
				<span>{{account.platform_nickname}}</span>
			</view>
			<view class="account_fans">
				<p style="padding-right: 20rpx;color:#A8A8A8;">粉丝数</p>
				<p>{{account.show_fans_count}}</p>
			</view>
			<view class="account_btn">
				<image :src="picture.togoimg" mode="" style="width: 16rpx;height: 30rpx;"></image>
			</view>
		</view>


		<view class="block"></view>
		<view class="submit">
			<button type="default" class="submit_btn" @click="submit()"> 确认报名</button>
		</view>
	</view>
</template>

<script>
	import region from '@/components/pca-code.json';
	import mvBar from "@/components/mys_navBar/mysNavBar";
	import {
		fansview
	} from '@/components/utils.js';
	export default {
		components: {
			mvBar
		},
		data() {
			return {
				navH: getApp().globalData.navHeight,
				picture: getApp().globalData.picture,
				mysNavConfig: {
					isHome: false,
					/* 固定导航  */
					navFixed: true,
					/* 标题 （屏幕中心居中 两边图标中心居中使用slot center1） */
					navTitle: {
						text: "信息确认",
						color: "",
						fontSize: "32rpx", // px upx rpx
						fontWeight: "", // 100 - 700
					},
					btnType: "type2",
					onLeftClick: '',
					/* type2 按钮 */
					type2Config: {
						// 左图标
						leftPath: "https://horastar.obs.cn-east-3.myhuaweicloud.com/talent/png2.png",
						// 右图标
						rightPath: "https://horastar.obs.cn-east-3.myhuaweicloud.com/talent/png4.png",
						// 圆角
						radius: "40rpx",
					},
				},

				selection: {},
				youngTeamId: "",
				youngLeadTeamId: "",
				mainImg: "https://horastar.obs.cn-east-3.myhuaweicloud.com/backstage_upload/bb531ede-28b5-49a0-8431-a1608fd35890.png",
				account_id: -1,
				address_id: -1,
				address: null,
				project: null,
				account: null,
				strategy: null,
				thirdPlatform: [],
			}
		},
		onShow() {
			// 根据address_id查询address
			this.getDefaultAddress();
			// 查询account	
			this.getAccount();
		},
		onLoad(options) {
			this.textObj = options.textObj.replace(/""/g, "");
			this.textObj = JSON.parse(decodeURIComponent(this.textObj))
			console.log(this.textObj)
			this.selection = this.textObj.selection
			this.youngTeamId = this.textObj.youngTeamId
			this.youngLeadTeamId = this.textObj.youngLeadTeamId

			for (let i = 0; i < this.selection.Product.ProductPhoto.length; ++i) {
				if (this.selection.Product.ProductPhoto[i].Symbol === 1) {
					this.mainImg = this.selection.Product.ProductPhoto[i].PhotoUrl
				}
			}
			console.log("youngLeadTeamId: ", this.youngLeadTeamId)
			if (this.youngLeadTeamId === "") {
				this.getLeadYoungTeamId()
			}
		},
		methods: {
			handleCopy(content) {
				wx.setClipboardData({
					data: content,
					success: function(res) {
						console.log("复制成功");
					}
				});
			},
			getLeadYoungTeamId() {
				// 调用后端接口，创建young之团，若young之团存在则返回teamid，否则创建young之团并返回id
				return this.$https.post('/youngee/c/t/p/add-young-team', {
						selection_id: this.selection.selection_id,
						project_type: 2,
					})
					.then(res => {
						console.log(res)
						this.youngLeadTeamId = res.data.data;
					})
			},
			getAccount() {
				this.$https.get('/youngee/c/t/g/get-talent-account')
					.then(res => {
						console.log(res)
						console.log(res.data.data)
						if (res.data.code !== -3) {
							let account = res.data.data
							while (this.selection == null) {} // 这句很危险
							for (var i = 0; i < account.length; i++) {
								if (this.selection.platform == account[i].platform_id) {
									this.account = account[i]
								}
							}
							this.account.show_fans_count = fansview(this.account.fans_count)
						}
					})
			},
			getDefaultAddress() {
				this.$https.get('/youngee/c/t/g/get-talent-default-address').then(res => {
					console.log(res.data.data)
					this.address = res.data.data;
					let a = this.address.region_code.toString().slice(0, 2)
					let b = this.address.region_code.toString().slice(0, 4)
					let c = 0
					for (var i = 0; i < region.length; i++) {
						if (region[i].code == a) {
							a = region[i].name
							for (var j = 0; j < region[i].children.length; j++) {
								if (region[i].children[j].code == b) {
									b = region[i].children[j].name
									for (var o = 0; o < region[i].children[j].children.length; o++) {
										if (region[i].children[j].children[o].code == this.address
											.region_code) {
											c = region[i].children[j].children[o].name
										}
									}
								}

							}
						}
					}
					this.address.full_detail_addr = a + b + c + this.address.detail_addr
				})
			},
			editAddress() {
				uni.navigateTo({
					url: '/page_mycenter/myinformation/addlocation?address_id=' + this.address.address_id +
						'&ismodify=1'
				});
			},
			editAccount() {
				uni.navigateTo({
					url: '/page_mycenter/myinformation/bindaccount?platform_id=' + this.account.platform_id +
						'&account_id=' +
						this.account.account_id
				});
			},
			debugSubmit() {
				uni.navigateTo({
					url: '/page_tasksquare/wholetask/success'
				});
			},
			// 提交确认报名
			async submit() {
				console.log(this.project)
				// 1. 判断任务是否截止
				await this.$https.get('/youngee/c/t/g/get-selection-detail' +
					"?" +
					"selectionid" +
					"=" +
					this.selection.selection_id
				).then(res => {
					if (res.data.code === 0) {
						var newdate = new Date()
						var endTime = new Date(this.selection.task_ddl.replace(
							/-/g, "/"));
						if (endTime - newdate < 0) {
							// 招募截止
							uni.showToast({
								title: "任务已结束",
								duration: 1000,
							});
							uni.navigateTo({
								url: '/pages/selectionsquare/selectionsquare'
							});
						}
					}
				})
				// 2. 插入一条任务
				// 如果是垫付买样则进行支付
				let that = this
				if (this.selection.sample_mode === 2) {
					console.log("支付")
					this.$https.post('/youngee/c/api/t/wxpay/pay', {
						amount: this.selection.price * 100,
						description: this.selection.selection_name,
					}).then(res => {
						console.log(res)
						let data = res.data.data
						wx.requestPayment({
							"timeStamp": data.time_stamp,
							"nonceStr": data.nonce_str,
							"package": data.package,
							"signType": "RSA",
							"paySign": data.pay_sign,
							"success": function(res) {
								// 支付成功时执行
								that.$https.post('/youngee/c/t/p/sign-up-sec-task', {
									address_id: that.address.address_id,
									selection_id: that.selection.selection_id,
									lead_team_id: that.youngLeadTeamId,
									team_id: that.youngTeamId,
								}).then(res => {
									if (res.data.code == 0) {
										var data = {
											task_id: res.data.data.task_id
										};
										data = JSON.stringify(data)
										uni.navigateTo({
											url: '/page_selectionsquare/selectiondetail/success?textObj=' +
												encodeURIComponent(
													data)
										});
									} else {
										uni.showModal({
											content: '网络繁忙，请小主稍后再试~',
										});
									}
								})
								console.log("支付成功: ", res.errMsg)
							},
							"fail": function(res) {
								// 调起失败或取消支付时执行
								console.log("支付失败: ", res.errMsg)
								uni.showModal({
									content: "支付失败，请重试",
								});
							},
							"complete": function(res) {
								// 成功或失败都会执行
								console.log("支付结束: ", res.errMsg)
							}
						})
					})
				} else {
					// 否则直接报名
					this.$https.post('/youngee/c/t/p/sign-up-sec-task', {
						address_id: this.address.address_id,
						selection_id: this.selection.selection_id,
						lead_team_id: this.youngLeadTeamId,
						team_id: this.youngTeamId,
					}).then(res => {
						if (res.data.code == 0) {
							var data = {
								task_id: res.data.data.task_id
							};
							data = JSON.stringify(data)
							uni.navigateTo({
								url: '/page_selectionsquare/selectiondetail/success?textObj=' +
									encodeURIComponent(
										data)
							});
						} else {
							uni.showModal({
								content: '网络繁忙，请小主稍后再试~',
							});
						}
					})
				}
			},
		}
	}
</script>

<style lang="scss" scoped>
	text {
		font-size: 32rpx;
	}

	p {
		font-size: 32rpx;
	}

	.basicInfo {
		display: flex;
		margin: 0 40rpx;
		padding: 30rpx 0;

		.basicInfo_txt {
			margin-left: 40rpx;
			padding-top: 20rpx;
		}
	}

	.address {
		display: flex;
		margin: 30rpx 40rpx 0;
		padding: 30rpx 0;
		justify-content: space-around;

		.address_icon {
			vertical-align: middle;
			width: 50rpx;
			height: 50rpx;
			display: inline-block;
			padding-right: 30rpx;
		}

		.address_edit {}

		.address_edit image {
			vertical-align: middle;
			width: 50rpx;
			height: 50rpx;
			display: inline-block;
			padding-right: 14rpx;
		}

		.ipon {
			color: #333333;
			font-size: 30rpx;
			margin-bottom: 10rpx;
		}
	}

	.keyInfo {
		margin: 30rpx 40rpx;
	}

	.keyInfo span {
		display: flex;
		align-items: center;
		margin: 10rpx 0;
	}

	.keyInfo p {
		margin: 25rpx 0;
	}


	.account {
		display: flex;
		align-items: center;
		width: 690rpx;
		padding: 24rpx 0;
		margin: 0 auto;

		.account_txt {
			display: inline-block;
			padding: 0 0 0 1%;
			width: 400rpx;
		}

		.account_txt span {
			color: #333333;
			font-weight: 550;
			text-indent: 2em;
			font-size: 32rpx;
		}


		.account_txt image {
			vertical-align: middle;
			width: 50rpx;
			height: 50rpx;
			display: inline-block;
			padding-right: 14rpx;
		}

		.account_fans {
			display: flex;
			width: 250rpx;
		}

		.account_fans p {
			display: inline-block;
			color: #333333;
			font-weight: 550;
		}

		.account_btn {}
	}

	.block {
		width: 100%;
		height: 100rpx;
		margin-top: 5%;
	}

	.submit {
		box-shadow: 0rpx 5rpx 40rpx #ccc;
		width: 100%;
		position: fixed;
		bottom: 0rpx;
		display: flex;
		height: 90rpx;
		padding-top: 2%;
		background-color: #FFFFFF;

		.submit_btn {
			width: 60%;
			background-color: #FCCF41;
			border-radius: 20rpx;
			font-size: 36rpx;
			line-height: 200%;
			letter-spacing: 10rpx;
			height: 80%;
		}

	}
</style>